//.----------------.
//|                |
//|     Config     |
//|                |
//'----------------'

#ifndef _GLCUBECONFIG_H_
#define _GLCUBECONFIG_H_

#include <stdio.h>
#include <CheckBox.h>
#include <MenuField.h>
#include <MenuItem.h>
#include <MenuBar.h>
#include <Slider.h>
#include <StringView.h>
#include <View.h>

#include "support.h"

//*********************************************************************************************

enum {
		GLC_NUMBER_CUBES	= 'numc',
		GLC_CUBE_SIZE		= 'size',
		GLC_CUBE_SPIN		= 'spin',
		GLC_NOBOUNDS		= 'bnds',
		GLC_WIREFRAME		= 'wire',
		GLC_FOUNTAIN		= 'foun',
		GLC_LIGHTS			= 'lite',
		GLC_COLLISIONS		= 'bang',
		GLC_OPAQUE			= 'glas',
		GLC_SOLID_COLOR		= 'sold',
		GLC_PULSATE			= 'puls',
		GLC_CUBE			= 'cube',
		GLC_PYRAMID			= 'pyra',
		GLC_DIAMOND			= 'diam',
		GLC_GEM				= 'jems',
		GLC_SHAPES			= 'shap',
		GLC_NONE			= 'none',
		GLC_ROCK			= 'rock',
		GLC_FPS				= 'sfps'
};

//******************************************

class GLCubeConfig : public BView
{
	public:
		GLCubeConfig(BRect frame, attrib *props);
		
		void AttachedToWindow();
		void MessageReceived(BMessage *msg);
		
	private:
		attrib 		*properties;
	
		uint32		window_flags;
		
		BSlider		*slider;
		BSlider		*sslider;
		BSlider		*rslider;
		BCheckBox	*nobounds;
		BCheckBox	*wireframe;
		BCheckBox	*fountain;
		BCheckBox	*lights;
		BCheckBox	*opaque;
		BCheckBox	*solidcolor;
		BCheckBox	*pulsate;
		BCheckBox	*collisions;
		BCheckBox	*showfps;
		BMenuField	*shapes;
		BMenu		*menu;
		BMenuItem	*cube;
		BMenuItem	*pyramid;
		BMenuItem	*gem;
		BMenuItem	*diamond;
		BMenu		*menu2;
		BMenuItem	*none;
		BMenuItem	*rock;
};

#endif