//.----------------.
//|                |
//| GLCubeWindow.h |
//|                |
//'----------------'

#ifndef _GLCUBEWINDOW_H_
#define _GLCUBEWINDOW_H_

#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <Bitmap.h>
#include <DirectGLWindow.h>
#include <TranslationUtils.h>
#include <View.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "support.h"
#include "FPS.h"

class GLWindow : public BDirectGLWindow
{
	public:
		GLWindow(BRect rect, attrib *properties);
		GLWindow();
		virtual ~GLWindow(void);
		virtual BRect UpdateGLRect(BRect window_rect);
		void    GetTexture(GLuint* texture, const char *filename); 
		void 	LoadTexture(BBitmap *source, GLuint id);
		status_t StartGL( uint32 deviceID, BRect rect);
		static int32 render_thread( void *data );
		void	DrawThread(void);
		void	Init(void);
		void 	GenerateLists(void);
		void 	DrawCube (void);
		void 	DrawPyramid (void);
		void 	DrawJem (void);
		void 	DrawDiamond (void);
		void 	SetAlpha (GLfloat alpha);
		
		bool	window_teardown;
		thread_id	draw_thread;

	private:
		
		attrib *properties;
		
		FPS	timer;
		bigtime_t time;
		int temp;
	
		Cube	Object[51];
		GLuint face_texture;
		
		int		j;
};

#endif